//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// Programmateur d'EEPROM Microwire 93xx    
// (C) Fabrice Sincre
// Borland Builder 5

TForm1 *Form1;

// variables globales
int adresse_courante ;
int nbbitadresse = 7;    // nombre de bits de l'adresse
int adressefin = 127 ;
int A[11]={0}; // 11 bits de l'adresse (A10 ... A0) A10 = MSB
                            // adressebinaire[0]-> A0 etc ...

int octet[2048] = {0} ;   // octet[0] contient la valeur dcimale
                                // de l'octet de l'adresse 0, etc

int octet_bak[2048] = {0} ;
bool verification = false ;

int flagREAD = 0;
int flagWRITE = 0;
int flagREADoct = 0;
int flagEWEN = 0 ;
int flagEWDS = 0 ;
int flagERAL = 0 ;
int flagERASE = 0 ;
int flagWRAL = 0;
int flagWRITEfichier = 0 ;

unsigned char tableau[3];     // TX (RS232)

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
StringGrid1->Cells[0][0]="0x";
for (int i=1 ; i<17 ; i++) StringGrid1->Cells[i][0]=IntToHex(i-1,1);
for (int i=1 ; i<129 ; i++) StringGrid1->Cells[0][i]=IntToHex(16*(i-1),3);
}
//---------------------------------------------------------------------------

void AFFICHAGE (void)
{
for (int j=0 ; j<2048 ;j++)
                {
                        if (j <= adressefin)
                        {
                                Form1->StringGrid1->Cells[1 + j%16][1 + j/16]=IntToHex(octet[j],2);
                        }
                        else
                        {
                                Form1->StringGrid1->Cells[1 + j%16][1 + j/16]="--"  ;
                        }
                }
}

void READ(int adresse)
{
// cette fonction retourne la valeur de la donne situe  l'adresse spcifie.

        if ((adresse < 0) || (adresse > adressefin ))
        {
                Application->MessageBox("Erreur inattendue !","Erreur 01",MB_OK);
                return ;
        }

        // conversion dcimal -> binaire
        int adresse0  ;
        adresse0 = adresse;
        for (int i=0 ; i < nbbitadresse ; i++)
        {
                A[i] = adresse0 % 2 ; // reste de la division
                adresse0 = adresse0 /2 ;
        }

        tableau[0]=0x00;

        if (Form1->RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x03;
        if (Form1->RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x06;
        if (Form1->RadioGroup1 -> ItemIndex == 2) tableau[1]= 8*1 + 4*1 + 2*0 + A[8];
        if (Form1->RadioGroup1 -> ItemIndex == 3) tableau[1]= 16*1 + 8*1 + 4*0 + 2*A[9] + A[8];
        if (Form1->RadioGroup1 -> ItemIndex == 4) tableau[1]= 32*1 + 16*1 + 8*0 + 4*A[10] + 2*A[9] + A[8];

        if (Form1->RadioGroup1 -> ItemIndex == 0) tableau[2]= 128*0 + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 1) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 2) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 3) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 4) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];

        Form1->ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
     

return;
}

//---------------------------------------------------------------------------

void WRITE (int adresse , int data)
{
// cette fonction crit la donne "data"  l'adresse "adresse"

        // test validit de l'adresse
        if ((adresse < 0) || (adresse > adressefin ))
        {
                Application->MessageBox("Erreur inattendue !","Erreur 02",MB_OK);
                return ;
        }

        // conversion dcimal -> binaire
        int adresse0;
        adresse0 = adresse;
        for (int i=0 ; i < nbbitadresse ; i++)
        {
                A[i] = adresse0 % 2 ; // reste de la division
                adresse0 = adresse0 /2 ;
        }

        // test de validit de la valeur de la donne
        if ((data < 0) || (data > 255 ))
        {
                Application->MessageBox("Erreur inattendue !","Erreur 03",MB_OK);
                return ;
        }

        if (Form1->RadioGroup1 -> ItemIndex == 0) tableau[0]= 0x02;
        if (Form1->RadioGroup1 -> ItemIndex == 1) tableau[0]= 0x05;
        if (Form1->RadioGroup1 -> ItemIndex == 2) tableau[0]= 8*1 + 4*0 + 2*1 + A[8];
        if (Form1->RadioGroup1 -> ItemIndex == 3) tableau[0]= 16*1 + 8*0 + 4*1 + 2*A[9] + A[8];
        if (Form1->RadioGroup1 -> ItemIndex == 4) tableau[0]= 32*1 + 16*0 + 8*1 + 4*A[10] + 2*A[9] + A[8];

        if (Form1->RadioGroup1 -> ItemIndex == 0) tableau[1]= 128*1 + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 1) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 2) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 3) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (Form1->RadioGroup1 -> ItemIndex == 4) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];

        tableau[2]=data;

        Form1->ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
     

return;
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
ComPort1->Connected=true; //Ouverture du port (prt  communiquer)

Button1 ->Enabled =false;
Button2 ->Enabled =true;
GroupBox1->Enabled =true;
Button9 ->Enabled =false;
RadioGroup1 -> Enabled = false ;

Edit1read->Text="000";
Edit5write->Text="000";
Edit4donneeWRITE->Text="00";
Edit3erase->Text="000";
EditWRALdata->Text="00";


ButtonREAD->Enabled=false;
ButtonEWEN->Enabled=false;
ButtonEWDS->Enabled=false;
ButtonWRITE->Enabled=false;
ButtonWRAL->Enabled=false;
ButtonERAL->Enabled=false;
ButtonERASE->Enabled=false;
Button3->Enabled=true;
ButtonWRITEfichier->Enabled=false;

ProgressBar1->Position = 0;
GroupBox2->Visible = false;

verification = false ;

flagWRAL = 0 ;
flagWRITE = 0 ;
flagREAD = 0;
flagREADoct = 0;
flagEWEN = 0 ;
flagEWDS = 0 ;
flagERAL = 0 ;
flagERASE = 0 ;
flagWRITEfichier = 0 ;

for (int j=0 ; j<2048 ;j++)
        {
                // mise  jour affichage
                if (j <= adressefin)
                {
                        StringGrid1->Cells[1 + j%16][1 + j/16]=""  ;
                }
                else
                {
                        StringGrid1->Cells[1 + j%16][1 + j/16]="--"  ;
                }
        }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
// Fermeture du port

ComPort1->Connected=false; //Fermeture du port (arrt des communications)
Button1 ->Enabled =true;
Button2 ->Enabled =false;
GroupBox1->Enabled =false;
Button9 ->Enabled =true;
RadioGroup1 -> Enabled = true ;

flagWRAL = 0 ;
flagWRITE = 0 ;
flagREAD = 0;
flagREADoct = 0;
flagEWEN = 0 ;
flagEWDS = 0 ;
flagERAL = 0 ;
flagERASE = 0 ;
flagWRITEfichier = 0 ;

ProgressBar1->Position = 0;
GroupBox2->Visible = false;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
ComPort1->ShowSetupDialog ();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonREADClick(TObject *Sender)
{

// READ

if (flagREAD == 0)
{

        // test de validit de l'adresse hex.
        
        if (Edit1read->Text.Length() != 3)
        {
                Application->MessageBox("Adresse hexadcimale non valide (3 chiffres) !","Erreur 04",MB_OK);
                Edit1read->Text ="";
                return;
        }

        if (( Edit1read->Text.SubString(1, 1) < "0" ||  Edit1read-> Text.SubString(1, 1) > "9" ) && (Edit1read-> Text.SubString(1, 1) <"A" || Edit1read-> Text.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 05",MB_OK);
                Edit1read->Text ="";
                return;
        }
        if (((Edit1read->Text.SubString(2, 1) <"0") || (Edit1read-> Text.SubString(2, 1) >"9")) && ((Edit1read-> Text.SubString(2, 1) <"A") || (Edit1read-> Text.SubString(2, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 06",MB_OK);
                Edit1read->Text ="";
                return;
        }
        if (((Edit1read->Text.SubString(3, 1) <"0") || (Edit1read-> Text.SubString(3, 1) >"9")) && ((Edit1read-> Text.SubString(3, 1) <"A") || (Edit1read-> Text.SubString(3, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 07",MB_OK);
                Edit1read->Text ="";
                return;
        }
        // conversion hexadcimal en dcimal

        int chiffre[3] ;
        int adress ;
        int adress0;

        for (int i=1; i<=3;i++)
        {
                if (Edit1read-> Text.SubString(i, 1) =="0") chiffre[3-i] = 0;
                if (Edit1read-> Text.SubString(i, 1) =="1") chiffre[3-i] = 1;
                if (Edit1read-> Text.SubString(i, 1) =="2") chiffre[3-i] = 2;
                if (Edit1read-> Text.SubString(i, 1) =="3") chiffre[3-i] = 3;
                if (Edit1read-> Text.SubString(i, 1) =="4") chiffre[3-i] = 4;
                if (Edit1read-> Text.SubString(i, 1) =="5") chiffre[3-i] = 5;
                if (Edit1read-> Text.SubString(i, 1) =="6") chiffre[3-i] = 6;
                if (Edit1read-> Text.SubString(i, 1) =="7") chiffre[3-i] = 7;
                if (Edit1read-> Text.SubString(i, 1) =="8") chiffre[3-i] = 8;
                if (Edit1read-> Text.SubString(i, 1) =="9") chiffre[3-i] = 9;
                if (Edit1read-> Text.SubString(i, 1) =="A") chiffre[3-i] = 10;
                if (Edit1read-> Text.SubString(i, 1) =="B") chiffre[3-i] = 11;
                if (Edit1read-> Text.SubString(i, 1) =="C") chiffre[3-i] = 12;
                if (Edit1read-> Text.SubString(i, 1) =="D") chiffre[3-i] = 13;
                if (Edit1read-> Text.SubString(i, 1) =="E") chiffre[3-i] = 14;
                if (Edit1read-> Text.SubString(i, 1) =="F") chiffre[3-i] = 15;
        }

        adress = chiffre[2]*256 + chiffre[1]*16 + chiffre[0] ;

        if (adress < 0 || adress > 4095)
        {
                Application->MessageBox("Erreur inattendue !","Erreur 08",MB_OK);
                return ;
        }


        if ((adress < 0) || (adress > adressefin ))
        {
                ShowMessage(AnsiString("L'adresse doit tre comprise entre 000 et ") + IntToHex(adressefin,3));
                Edit1read->Text = "";
                return;
        }

        // conversion dcimal -> binaire
        adress0 = adress;
        for (int i=0 ; i < nbbitadresse ; i++)
        {
                A[i] = adress0 % 2 ; // reste de la division
                adress0 = adress0 /2 ;
        }

        flagREAD = 1;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagWRITE = 0;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        Edit2donneeREAD->Text = "" ;

        tableau[0]=0x00;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x03;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x06;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 8*1 + 4*1 + 2*0 + A[8];
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 16*1 + 8*1 + 4*0 + 2*A[9] + A[8];
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 32*1 + 16*1 + 8*0 + 4*A[10] + 2*A[9] + A[8];

        if (RadioGroup1 -> ItemIndex == 0) tableau[2]= 128*0 + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 1) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 2) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 3) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 4) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
if (RadioGroup1 -> ItemIndex == 0)
{
        nbbitadresse = 7;
        adressefin = 128 -1 ;
}
if (RadioGroup1 -> ItemIndex == 1)
{
        nbbitadresse = 8;
        adressefin = 256 -1 ;
}
if (RadioGroup1 -> ItemIndex == 2)
{
        nbbitadresse = 9;
        adressefin = 512 -1 ;
}
if (RadioGroup1 -> ItemIndex == 3)
{
        nbbitadresse = 10;
        adressefin = 1024 -1 ;
}
if (RadioGroup1 -> ItemIndex == 4)
{
        nbbitadresse = 11;
        adressefin = 2048 -1 ;
}


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
// lecture mot  mot de toute la mmoire
if (flagREADoct == 0)
{
        GroupBox1->Enabled = false;
        flagREADoct = 1 ;
        flagREAD = 0 ;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagWRITE = 0;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        for (int j=0 ; j<2048 ;j++)
        {
                // mise  jour affichage
                if (j <= adressefin)
                {
                        StringGrid1->Cells[1 + j%16][1 + j/16]=""  ;
                }
                else
                {
                        StringGrid1->Cells[1 + j%16][1 + j/16]="--"  ;
                }
        }

        adresse_courante = 0 ;
        ProgressBar1->Position = 0;
        GroupBox2->Caption ="Progression -> phase de lecture";
        GroupBox2->Visible = true;
        READ(adresse_courante) ; // lecture de l'adresse 0x000
        ButtonREAD->Enabled=true;
        ButtonEWEN->Enabled=true;
        ButtonEWDS->Enabled=true;
}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonEWENClick(TObject *Sender)
{
// EWEN

if (flagEWEN == 0)
{

        ButtonWRITE -> Enabled = true;
        ButtonERASE -> Enabled = true;
        ButtonWRAL -> Enabled = true;
        ButtonERAL -> Enabled = true;
        ButtonWRITEfichier -> Enabled = true;

        flagREAD = 0 ;
        flagREADoct = 0;
        flagEWEN = 1 ;
        flagEWDS = 0 ;
        flagWRITE = 0;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        tableau[0]=0x00;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x02;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x04;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 0x09;
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 0x13;
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 0x26;

        if (RadioGroup1 -> ItemIndex == 0) tableau[2]= 0x60;
        if (RadioGroup1 -> ItemIndex == 1) tableau[2]= 0xC0;
        if (RadioGroup1 -> ItemIndex == 2) tableau[2]= 0x80;
        if (RadioGroup1 -> ItemIndex == 3) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 4) tableau[2]= 0x00;

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonEWDSClick(TObject *Sender)
{
// EWDS

if (flagEWDS == 0)
{

        ButtonWRITE -> Enabled = false;
        ButtonERASE -> Enabled = false;
        ButtonWRAL -> Enabled = false;
        ButtonERAL -> Enabled = false;
        ButtonWRITEfichier -> Enabled = false;

        flagREAD = 0 ;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 1 ;
        flagWRITE = 0;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        tableau[0]=0x00;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x02;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x04;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 0x08;
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 0x10;
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 0x20;

        if (RadioGroup1 -> ItemIndex == 0) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 1) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 2) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 3) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 4) tableau[2]= 0x00;

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonWRITEClick(TObject *Sender)
{

// WRITE

if (flagWRITE == 0)

{

 // test de validit de l'adresse hex.
        
        if (Edit5write->Text.Length() != 3)
        {
                Application->MessageBox("Adresse hexadcimale non valide (3 chiffres) !","Erreur 09",MB_OK);
                Edit5write->Text ="";
                return;
        }

        if (( Edit5write->Text.SubString(1, 1) < "0" ||  Edit5write-> Text.SubString(1, 1) > "9" ) && (Edit5write-> Text.SubString(1, 1) <"A" || Edit5write-> Text.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 10",MB_OK);
                Edit5write->Text ="";
                return;
        }
        if (((Edit5write->Text.SubString(2, 1) <"0") || (Edit5write-> Text.SubString(2, 1) >"9")) && ((Edit5write-> Text.SubString(2, 1) <"A") || (Edit5write-> Text.SubString(2, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 11",MB_OK);
                Edit5write->Text ="";
                return;
        }
        if (((Edit5write->Text.SubString(3, 1) <"0") || (Edit5write-> Text.SubString(3, 1) >"9")) && ((Edit5write-> Text.SubString(3, 1) <"A") || (Edit5write-> Text.SubString(3, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 12",MB_OK);
                Edit5write->Text ="";
                return;
        }
        // conversion hexadcimal en dcimal

        int chiffre[3] ;
        int adress ;
        int adress0;

        for (int i=1; i<=3;i++)
        {
                if (Edit5write-> Text.SubString(i, 1) =="0") chiffre[3-i] = 0;
                if (Edit5write-> Text.SubString(i, 1) =="1") chiffre[3-i] = 1;
                if (Edit5write-> Text.SubString(i, 1) =="2") chiffre[3-i] = 2;
                if (Edit5write-> Text.SubString(i, 1) =="3") chiffre[3-i] = 3;
                if (Edit5write-> Text.SubString(i, 1) =="4") chiffre[3-i] = 4;
                if (Edit5write-> Text.SubString(i, 1) =="5") chiffre[3-i] = 5;
                if (Edit5write-> Text.SubString(i, 1) =="6") chiffre[3-i] = 6;
                if (Edit5write-> Text.SubString(i, 1) =="7") chiffre[3-i] = 7;
                if (Edit5write-> Text.SubString(i, 1) =="8") chiffre[3-i] = 8;
                if (Edit5write-> Text.SubString(i, 1) =="9") chiffre[3-i] = 9;
                if (Edit5write-> Text.SubString(i, 1) =="A") chiffre[3-i] = 10;
                if (Edit5write-> Text.SubString(i, 1) =="B") chiffre[3-i] = 11;
                if (Edit5write-> Text.SubString(i, 1) =="C") chiffre[3-i] = 12;
                if (Edit5write-> Text.SubString(i, 1) =="D") chiffre[3-i] = 13;
                if (Edit5write-> Text.SubString(i, 1) =="E") chiffre[3-i] = 14;
                if (Edit5write-> Text.SubString(i, 1) =="F") chiffre[3-i] = 15;
        }

        adress = chiffre[2]*256 + chiffre[1]*16 + chiffre[0] ;

        if (adress < 0 || adress > 4095)
        {
                Application->MessageBox("Erreur inattendue !","Erreur 13",MB_OK);
                return ;
        }


        if ((adress < 0) || (adress > adressefin ))
        {
                ShowMessage(AnsiString("L'adresse doit tre comprise entre 000 et ") + IntToHex(adressefin,3));
                Edit5write->Text = "";
                return;
        }

        // conversion dcimal -> binaire
        adress0 = adress;
        for (int i=0 ; i < nbbitadresse ; i++)
        {
                A[i] = adress0 % 2 ; // reste de la division
                adress0 = adress0 /2 ;
        }

        // test de validit de la valeur de la donne hex.

        if (Edit4donneeWRITE->Text.Length() != 2)
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 14",MB_OK);
                Edit4donneeWRITE->Text ="";
                return;
        }

        if (( Edit4donneeWRITE->Text.SubString(1, 1) < "0" ||  Edit4donneeWRITE-> Text.SubString(1, 1) > "9" ) && (Edit4donneeWRITE-> Text.SubString(1, 1) <"A" || Edit4donneeWRITE-> Text.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 15",MB_OK);
                Edit4donneeWRITE->Text ="";
                return;
        }
        if (( Edit4donneeWRITE->Text.SubString(2, 1) <"0" || Edit4donneeWRITE-> Text.SubString(2, 1) >"9") && (Edit4donneeWRITE-> Text.SubString(2, 1) <"A" || Edit4donneeWRITE-> Text.SubString(2, 1) >"F"))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 16",MB_OK);
                Edit4donneeWRITE->Text ="";
                return;
        }

        // conversion hexadcimal en dcimal

        int data ;

        for (int i=1; i<=2;i++)
        {
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="0") chiffre[2-i] = 0;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="1") chiffre[2-i] = 1;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="2") chiffre[2-i] = 2;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="3") chiffre[2-i] = 3;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="4") chiffre[2-i] = 4;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="5") chiffre[2-i] = 5;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="6") chiffre[2-i] = 6;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="7") chiffre[2-i] = 7;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="8") chiffre[2-i] = 8;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="9") chiffre[2-i] = 9;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="A") chiffre[2-i] = 10;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="B") chiffre[2-i] = 11;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="C") chiffre[2-i] = 12;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="D") chiffre[2-i] = 13;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="E") chiffre[2-i] = 14;
                if (Edit4donneeWRITE-> Text.SubString(i, 1) =="F") chiffre[2-i] = 15;
        }

        data = chiffre[1]*16 + chiffre[0] ;

        if (data < 0 || data > 255)
        {
                Application->MessageBox("Erreur inattendue !","Erreur 17",MB_OK);
                return ;
        }

        flagWRITE = 1 ;
        flagREAD = 0;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        if (RadioGroup1 -> ItemIndex == 0) tableau[0]= 0x02;
        if (RadioGroup1 -> ItemIndex == 1) tableau[0]= 0x05;
        if (RadioGroup1 -> ItemIndex == 2) tableau[0]= 8*1 + 4*0 + 2*1 + A[8];
        if (RadioGroup1 -> ItemIndex == 3) tableau[0]= 16*1 + 8*0 + 4*1 + 2*A[9] + A[8];
        if (RadioGroup1 -> ItemIndex == 4) tableau[0]= 32*1 + 16*0 + 8*1 + 4*A[10] + 2*A[9] + A[8];

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 128*1 + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];

        tableau[2]=data;

        octet[adress]=data;
        AFFICHAGE();

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonERALClick(TObject *Sender)
{
// ERAL

if (flagERAL == 0)
{
        for (int j=0 ; j <= adressefin ;j++)
        {
                        octet[j]=255;
        }

        AFFICHAGE();

        flagERAL = 1 ;
        flagWRITE = 0 ;
        flagREAD = 0;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagERASE = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        tableau[0]=0x00;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x02;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x04;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 0x09;
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 0x12;
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 0x24;

        if (RadioGroup1 -> ItemIndex == 0) tableau[2]= 0x40;
        if (RadioGroup1 -> ItemIndex == 1) tableau[2]= 0x80;
        if (RadioGroup1 -> ItemIndex == 2) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 3) tableau[2]= 0x00;
        if (RadioGroup1 -> ItemIndex == 4) tableau[2]= 0x00;

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonERASEClick(TObject *Sender)
{
// ERASE

if (flagERASE == 0)
{
        // test de validit de l'adresse hex.

        if (Edit3erase->Text.Length() != 3)
        {
                Application->MessageBox("Adresse hexadcimale non valide (3 chiffres) !","Erreur 18",MB_OK);
                Edit3erase->Text ="";
                return;
        }

        if (( Edit3erase->Text.SubString(1, 1) < "0" ||  Edit3erase-> Text.SubString(1, 1) > "9" ) && (Edit3erase-> Text.SubString(1, 1) <"A" || Edit3erase-> Text.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 19",MB_OK);
                Edit3erase->Text ="";
                return;
        }

        if (((Edit3erase->Text.SubString(2, 1) <"0") || (Edit3erase-> Text.SubString(2, 1) >"9")) && ((Edit3erase-> Text.SubString(2, 1) <"A") || (Edit3erase-> Text.SubString(2, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 20",MB_OK);
                Edit3erase->Text ="";
                return;
        }

        if (((Edit3erase->Text.SubString(3, 1) <"0") || (Edit3erase-> Text.SubString(3, 1) >"9")) && ((Edit3erase-> Text.SubString(3, 1) <"A") || (Edit3erase-> Text.SubString(3, 1) >"F")))
        {
                Application->MessageBox("Adresse hexadcimale non valide !","Erreur 21",MB_OK);
                Edit3erase->Text ="";
                return;
        }

        // conversion hexadcimal en dcimal

        int chiffre[3] ;
        int adress ;
        int adress0;

        for (int i=1; i<=3;i++)
        {
                if (Edit3erase-> Text.SubString(i, 1) =="0") chiffre[3-i] = 0;
                if (Edit3erase-> Text.SubString(i, 1) =="1") chiffre[3-i] = 1;
                if (Edit3erase-> Text.SubString(i, 1) =="2") chiffre[3-i] = 2;
                if (Edit3erase-> Text.SubString(i, 1) =="3") chiffre[3-i] = 3;
                if (Edit3erase-> Text.SubString(i, 1) =="4") chiffre[3-i] = 4;
                if (Edit3erase-> Text.SubString(i, 1) =="5") chiffre[3-i] = 5;
                if (Edit3erase-> Text.SubString(i, 1) =="6") chiffre[3-i] = 6;
                if (Edit3erase-> Text.SubString(i, 1) =="7") chiffre[3-i] = 7;
                if (Edit3erase-> Text.SubString(i, 1) =="8") chiffre[3-i] = 8;
                if (Edit3erase-> Text.SubString(i, 1) =="9") chiffre[3-i] = 9;
                if (Edit3erase-> Text.SubString(i, 1) =="A") chiffre[3-i] = 10;
                if (Edit3erase-> Text.SubString(i, 1) =="B") chiffre[3-i] = 11;
                if (Edit3erase-> Text.SubString(i, 1) =="C") chiffre[3-i] = 12;
                if (Edit3erase-> Text.SubString(i, 1) =="D") chiffre[3-i] = 13;
                if (Edit3erase-> Text.SubString(i, 1) =="E") chiffre[3-i] = 14;
                if (Edit3erase-> Text.SubString(i, 1) =="F") chiffre[3-i] = 15;
        }

        adress = chiffre[2]*256 + chiffre[1]*16 + chiffre[0] ;

        if (adress < 0 || adress > 4095)
        {
                Application->MessageBox("Erreur inattendue !","Erreur 22",MB_OK);
                return ;
        }


        if ((adress < 0) || (adress > adressefin ))
        {
                ShowMessage(AnsiString("L'adresse Hex. doit tre comprise entre 000 et ") + IntToHex(adressefin,3));
                Edit3erase->Text = "";
                return;
        }

        // conversion dcimal -> binaire
        adress0 = adress;
        for (int i=0 ; i<nbbitadresse ; i++)
        {
                A[i] = adress0 % 2 ; // reste de la division
                adress0 = adress0 /2 ;
        }

        flagERASE = 1 ;
        flagWRITE = 0 ;
        flagREAD = 0;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagERAL = 0 ;
        flagWRAL = 0 ;
        flagWRITEfichier = 0;

        tableau[0]=0x00;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x03;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x07;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 8*1 + 4*1 + 2*1 + A[8];
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 16*1 + 8*1 + 4*1 + 2*A[9] + A[8];
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 32*1 + 16*1 + 8*1 + 4*A[10] + 2*A[9] + A[8];

        if (RadioGroup1 -> ItemIndex == 0) tableau[2]= 128*1 + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 1) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 2) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 3) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];
        if (RadioGroup1 -> ItemIndex == 4) tableau[2]= 128*A[7] + 64*A[6] + 32*A[5] + 16*A[4] + 8*A[3] + 4*A[2] + 2*A[1] + A[0];

        octet[adress]=255;
        AFFICHAGE();

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;

}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonWRALClick(TObject *Sender)
{
// WRAL

if (flagWRAL == 0)
{
        // test de validit de la valeur de la donne hex.

        if (EditWRALdata->Text.Length() != 2)
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 23",MB_OK);
                EditWRALdata->Text ="";
                return;
        }

        if (( EditWRALdata->Text.SubString(1, 1) < "0" ||  EditWRALdata-> Text.SubString(1, 1) > "9" ) && (EditWRALdata-> Text.SubString(1, 1) <"A" || EditWRALdata-> Text.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 24",MB_OK);
                EditWRALdata->Text ="";
                return;
        }
        if (((EditWRALdata->Text.SubString(2, 1) <"0") || (EditWRALdata-> Text.SubString(2, 1) >"9")) && ((EditWRALdata-> Text.SubString(2, 1) <"A") || (EditWRALdata-> Text.SubString(2, 1) >"F")))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 25",MB_OK);
                EditWRALdata->Text ="";
                return;
        }

        // conversion hexadcimal en dcimal

        int chiffre[2] ;
        int data ;

        for (int i=1; i<=2;i++)
        {
                if (EditWRALdata-> Text.SubString(i, 1) =="0") chiffre[2-i] = 0;
                if (EditWRALdata-> Text.SubString(i, 1) =="1") chiffre[2-i] = 1;
                if (EditWRALdata-> Text.SubString(i, 1) =="2") chiffre[2-i] = 2;
                if (EditWRALdata-> Text.SubString(i, 1) =="3") chiffre[2-i] = 3;
                if (EditWRALdata-> Text.SubString(i, 1) =="4") chiffre[2-i] = 4;
                if (EditWRALdata-> Text.SubString(i, 1) =="5") chiffre[2-i] = 5;
                if (EditWRALdata-> Text.SubString(i, 1) =="6") chiffre[2-i] = 6;
                if (EditWRALdata-> Text.SubString(i, 1) =="7") chiffre[2-i] = 7;
                if (EditWRALdata-> Text.SubString(i, 1) =="8") chiffre[2-i] = 8;
                if (EditWRALdata-> Text.SubString(i, 1) =="9") chiffre[2-i] = 9;
                if (EditWRALdata-> Text.SubString(i, 1) =="A") chiffre[2-i] = 10;
                if (EditWRALdata-> Text.SubString(i, 1) =="B") chiffre[2-i] = 11;
                if (EditWRALdata-> Text.SubString(i, 1) =="C") chiffre[2-i] = 12;
                if (EditWRALdata-> Text.SubString(i, 1) =="D") chiffre[2-i] = 13;
                if (EditWRALdata-> Text.SubString(i, 1) =="E") chiffre[2-i] = 14;
                if (EditWRALdata-> Text.SubString(i, 1) =="F") chiffre[2-i] = 15;
        }

        data = chiffre[1]*16 + chiffre[0] ;

        if (data < 0 || data > 255)
        {
                Application->MessageBox("Erreur inattendue !","Erreur 26",MB_OK);
                return ;
        }

        for (int j=0 ; j <= adressefin ;j++)
        {
                octet[j] = data ;
        }

        AFFICHAGE();

        flagWRAL = 1 ;
        flagWRITE = 0 ;
        flagREAD = 0;
        flagREADoct = 0;
        flagEWEN = 0 ;
        flagEWDS = 0 ;
        flagERAL = 0 ;
        flagERASE = 0 ;
        flagWRITEfichier = 0;
        
        //nbcycle = 0 ;

        if (RadioGroup1 -> ItemIndex == 0) tableau[0]= 0x02;
        if (RadioGroup1 -> ItemIndex == 1) tableau[0]= 0x04;
        if (RadioGroup1 -> ItemIndex == 2) tableau[0]= 0x08;
        if (RadioGroup1 -> ItemIndex == 3) tableau[0]= 0x11;
        if (RadioGroup1 -> ItemIndex == 4) tableau[0]= 0x22;

        if (RadioGroup1 -> ItemIndex == 0) tableau[1]= 0x20;
        if (RadioGroup1 -> ItemIndex == 1) tableau[1]= 0x40;
        if (RadioGroup1 -> ItemIndex == 2) tableau[1]= 0x80;
        if (RadioGroup1 -> ItemIndex == 3) tableau[1]= 0x00;
        if (RadioGroup1 -> ItemIndex == 4) tableau[1]= 0x00;

        // 8 bits de donnes D7-D0

        tableau[2]=data;

        ComPort1->Write(tableau, 3); //Ecrit les 3 octets sur le port srie
        GroupBox1->Enabled = false;
}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonWRITEfichierClick(TObject *Sender)
{

if (flagWRITEfichier == 0)
{

        // lecture fichier
        int iFileHandle;
        int iFileLength;
        int iBytesRead;
        unsigned char *pszBuffer;   // 0  255
        if (OpenDialog1->Execute())
        {
                try
                {       // Ouverture du fichier en lecture seule.
                        // La valeur retourne reprsente le "descripteur" du fichier.
                        iFileHandle = FileOpen(OpenDialog1->FileName, fmOpenRead);

                        // Le pointeur de fichier est positionn  la fin du fichier.
                        // La valeur retourne est donc la taille du fichier (en octets).
                        iFileLength = FileSeek(iFileHandle,0,2);

                        if (iFileLength != (adressefin +1))
                        {
                                Application->MessageBox("La taille du fichier est incorrecte !","Erreur 27",MB_OK);
                                return;
                        }
                        // Le pointeur de fichier est positionn au dbut du fichier.
                        FileSeek(iFileHandle,0,0);

                        pszBuffer = new char[iFileLength + 1];

                        // FileRead lit iFileLength octets du fichier
                        // La valeur retourne est le nombre d'octets lus
                        iBytesRead = FileRead(iFileHandle, pszBuffer, iFileLength);
                        // Fermeture du fichier
                        FileClose(iFileHandle);

                        for (int j=0 ; j < iBytesRead ;j++)
                        {
                                octet[j] = pszBuffer[j];
                                octet_bak[j] = pszBuffer[j];
                        }

                        // mise  jour affichage
                        AFFICHAGE();

                        delete [] pszBuffer;

                        flagWRITEfichier = 1 ;
                        flagWRITE = 0 ;
                        flagREAD = 0;
                        flagREADoct = 0;
                        flagEWEN = 0 ;
                        flagEWDS = 0 ;
                        flagERAL = 0 ;
                        flagERASE = 0 ;
                        flagWRAL = 0 ;

                        GroupBox1->Enabled = false;
                        adresse_courante = 0 ;

                        ProgressBar1->Position = 0;
                        GroupBox2->Caption ="Progression -> phase d'criture";
                        GroupBox2->Visible = true;
                        WRITE(adresse_courante , octet[adresse_courante]) ; // criture  l'adresse 0x000
                }
                catch(...)
                {
                        Application->MessageBox("Impossible d'excuter l'une des oprations suivantes :\nOuvrir, Rechercher, Lire, Fermer.", "Erreur 28", MB_OK);
                }
        }
}

}
//---------------------------------------------------------------------------


void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM

try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on ne reoit qu'un seul octet du PIC

int drapeau = 0;
if (flagEWEN == 1)
{
        if (datarecu[0] != 1) Application->MessageBox("Erreur d'excution","Erreur 29",MB_OK);
        flagEWEN = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagEWDS == 1)
{
        if (datarecu[0] != 6) Application->MessageBox("Erreur d'excution","Erreur 30",MB_OK);
        flagEWDS = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagERAL == 1)
{
        if (datarecu[0] != 3) Application->MessageBox("Erreur d'excution","Erreur 31",MB_OK);
        flagERAL = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagWRITE == 1)
{
        if (datarecu[0] != 4) Application->MessageBox("Erreur d'excution","Erreur 32",MB_OK);
        flagWRITE = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagWRAL == 1)
{
        if (datarecu[0] != 5) Application->MessageBox("Erreur d'excution","Erreur 33",MB_OK);
        flagWRAL = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagERASE == 1)
{
        if (datarecu[0] != 2) Application->MessageBox("Erreur d'excution","Erreur 34",MB_OK);
        flagERASE = 0;
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagREAD == 1)
{
        flagREAD = 0;
        // Mise  jour de l'affichage
        Edit2donneeREAD->Text = IntToHex(datarecu[0],2);
        drapeau = 1;
        GroupBox1->Enabled = true;
}
if (flagREADoct == 1)
{
        octet[adresse_courante] = datarecu[0];

        if (adresse_courante >= adressefin)
        {
                flagREADoct = 0;
                GroupBox1->Enabled = true;
                // mise  jour affichage
                AFFICHAGE();

                ProgressBar1->Position = 0;
                GroupBox2->Caption ="Progression";
                GroupBox2->Visible = false;

                if (verification == true)
                {
                        bool verifOK = true;
                        for (int j=0 ; j <= adressefin ;j++)
                        {
                                if (octet[j] != octet_bak[j])verifOK = false ;
                        }
                        if (verifOK == true) Application->MessageBox("Le test de vrification a russi !","Ecriture EEPROM",MB_OK);
                        else  Application->MessageBox("Le test de vrification a chou !","Erreur 35",MB_OK);
                        verification = false;
                }
        }
        else
        {
        adresse_courante++;
        ProgressBar1->Position = 100.0*adresse_courante/adressefin ;
        READ(adresse_courante);    // fonction READ
        }
        drapeau = 1;
}

if (flagWRITEfichier == 1)
{
        if (datarecu[0] != 4)
        {
                Application->MessageBox("Erreur d'excution","Erreur 36",MB_OK);
                flagWRITEfichier = 0;
                GroupBox1->Enabled = true;
        }
        else
        {

        if (adresse_courante >= adressefin)
        {
                flagWRITEfichier = 0;
                GroupBox1->Enabled = true;

                // test de vrification   (lecture de toutes la mmoire)
                verification = true ; // indique que la vrification est en cours


                GroupBox1->Enabled = false;
                flagREADoct = 1 ;
                flagREAD = 0 ;
                flagEWEN = 0 ;
                flagEWDS = 0 ;
                flagWRITE = 0;
                flagERAL = 0 ;
                flagERASE = 0 ;
                flagWRAL = 0 ;
                flagWRITEfichier = 0;

                adresse_courante = 0 ;
                GroupBox2->Caption ="Progression -> phase de lecture (vrification)";
                ProgressBar1->Position = 0;
                READ(adresse_courante) ; // lecture de l'adresse 0x000
        }
        else
        {
                adresse_courante++;
                ProgressBar1->Position = 100.0*adresse_courante/adressefin ;
                WRITE(adresse_courante , octet[adresse_courante]);    // fonction READ
        }
        }
        drapeau = 1;
}

if (drapeau == 0) Application->MessageBox("Erreur inattendue !","Erreur 37",MB_OK);

delete [] datarecu;
datarecu = NULL;
}

catch(...)
{
Application->MessageBox("Erreur de format de rception !","Erreur 38",MB_OK);
}
}
//---------------------------------------------------------------------------






